﻿/// =====================================================================
/// Telerik DragDrop Hyper Example Sample Application.
/// =====================================================================
/// 
/// This application is an example of how the Telerik DragAndDrop can be used
/// to enchance an application. The application is build following the
/// Model-View-ViewModel pattern and can be used as a reference application for
/// this as well.
/// 
/// The code in this project is anotated with hyperlinks that you can
/// Control-Click to get to the respective part of the code. To enable the
/// hyperlinks, you need the following free Visual Studui Addin:
/// 
/// http://www.codeplex.com/hyperAddin
/// 
/// #Contets
///     DragDrop
///         Basics & Routed Events: Basic requirements and tricks to get the Drag/Drop
///             working and make your life easy.
///             - Include namespaces file:Page.xaml.cs#IncludeNamespaces
///             - Handle routed esvent file:Page.xaml.cs#AddHandler;
///             - Always handle a drag/drop event file file:Page.xaml.cs#RootHandlerTrue;
///         Application Behavior
///             - Give visual feedback to the user on drop possible file:Views\ApplicationDragDrop.cs#VisualFeedback
///             - Register class event hanbdlers: file:Views\ApplicationDragDrop.cs#Initialize
///             - Expand RadExpanders on drag over: file:Views\ApplicationDragDrop.cs#ExpnaderExpand
///             - Auto-Expand TreeViewItems on drag over: file:Views\ApplicationDragDrop.cs#TreeViewExpand
///             - We want a rich drag cue, better use a ViewModel: file:ViewModels\DragDropViewModel.cs#DragCueViewModel
///             - Drag Selected TreeViewItems: file:Views\ApplicationDragDrop.cs#SelectedTreeItems
///             - Drag Selected ListBoxItem: file:Views\ApplicationDragDrop.cs#SelectedListBoxItems
///             - Drag Selected GridViewRows: file:Views\ApplicationDragDrop.cs#GridViewRowsDrag
///             - Auto-Select TabItems on DragOver: file:Views\ApplicationDragDrop.cs#TabAutoSwitch
///             - Allow Drop for all GridRows: file:Views\ApplicationDragDrop.cs#GridViewMemberDrop
///             - Handle Drop for all GridRows file:Views\ApplicationDragDrop.cs#GridViewDropInfo
///         Business Logic
///             - Allow drop for TeamMember to Bug in the GridView: file:Views\ApplicationDragDrop.cs#GridViewMemberDrop
///     Model-View-ViewModel
///         - Common ViewModel Class file:ViewModels\ViewModelBase.cs#CommonViewModel
///         - Protected INotify Implementation file:ViewModels\ViewModelBase.cs#INotifyDefinition
///         - Data Source Abstraction file:Models\IBugTrackerDataSource.cs#Abstraction
///         - Dummy Data Source file:Models\DummyDataSource.cs
///         - How to bind to statics / singleton: file:ViewModels\BugTrackerProxy.cs#Singleton
///         - Forced Design Mode DesignMode file:ViewModels\BugTrackerViewModel.cs#DesignMode
///         - Handy Bindable Collections: file:ViewModels\BugTrackerViewModel.cs#BindsbleSelectedItems
///         - Handy Bindable Concatenation: file:ViewModels\BugTrackerViewModel.cs#BindableConcat
///         - The DragCue has a ViewModel as well: file:ViewModels\DragDropViewModel.cs#DragCueViewModel
///         - All Properties are Lazy: file:ViewModels\TeamMemberViewModel.cs#Lazy
///         - Converter Bool To Visibility: file:Views\BoolToVisibilityConverter.cs
///         - Converter DefaultValue: file:Views\DefaultValueConverter.cs
///     Misc / Utils
///         - MultiExpander Control: file:Controls\MultiExpander.cs
///         - (Double)Click to enchance any object: file:Controls\ClickHelper.cs
///         - How to add the Click Event behavior: file:Views\DataTemplatesProvider.xaml#ClickBehavior
///         - How to handle the double click: file:Page.xaml.cs#HandleDoubleClick
///         - String.Format Extension, Quite handy: file:Utils\Extensions.cs#Format
///
/// ============================================================================
/// Bindable Linq Notice
/// ============================================================================
/// This project uses a Reactice Programming library
/// called Bindable Linq, it can be downloaded from
/// http://bindablelinq.codeplex.com/ and it comes with its owne license,
/// provided below:
/// 
/// Copyright (c) 2007, Paul Stovell
/// All rights reserved.
///
/// Redistribution and use in source and binary forms, with or without 
/// modification, are permitted provided that the following conditions are met:
///
/// * Redistributions of source code must retain the above copyright notice,
///  this list of conditions and the following disclaimer.
///
/// * Redistributions in binary form must reproduce the above copyright 
/// notice, this list of conditions and the following disclaimer in the 
/// documentation and/or other materials provided with the distribution.
/// * Neither the name of Paul Stovell nor the names of its contributors 
/// may be used to endorse or promote products derived from this software 
/// without specific prior written permission.
///
/// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
/// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
/// IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
/// ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
/// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
/// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
/// OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
/// BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
/// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
/// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
/// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE
