﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace BugTrackerDragDrop.Views
{
	/// <summary>
	/// Converts bool values to visbility with the option to invert the result.
	/// </summary>
	public class BoolToVisibilityConverter : IValueConverter
	{
		public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
		{
			var boolValue = System.Convert.ToBoolean(value);
			if (parameter != null && "Invert".Equals(parameter))
			{
				boolValue = !boolValue;
			}
			return boolValue ? Visibility.Visible : Visibility.Collapsed;
		}

		public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
		{
			throw new NotImplementedException();
		}
	}
}
