﻿using System.Windows;
using BugTrackerDragDrop.ViewModels;
using Telerik.Windows.Controls;

namespace BugTrackerDragDrop.Views
{
    public class DefaultDataTemplateSelector : DataTemplateSelector
	{
		public static DataTemplatesProvider Provider
		{
			get
			{
				return DataTemplatesProvider.Instance;
			}
		}

		public override DataTemplate SelectTemplate(object item, DependencyObject container)
		{
			if (item is TeamMemberViewModel)
			{
				return Provider.Resources["TeamMemberTemplate"] as DataTemplate;
			}
			else if (item is TeamViewModel)
			{
				return Provider.Resources["TeamTemplate"] as DataTemplate;
			}
			else if (item is BugViewModel)
			{
				return Provider.Resources["BugTemplate"] as DataTemplate;
			}

			return null;
		}
	}
}
